/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: 
*/

#include "height_map.h"
#include "model.h"
#include "texture.h"
#include "vector.h"

#include "debug.h"

// INCLUDING SDL_Image
#ifdef HAVE_SDL_IMAGE_H
#include <SDL_image.h>
#else
#include <SDL/SDL_image.h>
#endif

HeightMap::HeightMap() : Model()
{
	
}

HeightMap::HeightMap(const char* height_map_name = NULL) : Model()
{
	heightMap =  IMG_Load(height_map_name);
	    if(heightMap!=NULL) {
		 PRINTF(0)("loading Image %s\n", height_map_name);
		 PRINTF(0)("width : %i\n", heightMap->w);
		 PRINTF(0)("hight : %i\n", heightMap->h);
		 PRINTF(0)("%i Byte(s) per Pixel \n", heightMap->format->BytesPerPixel);

		
		}
		 
	    else       PRINTF(4)("oops! couldn't load %s for some reason.\n", height_map_name);
}


HeightMap::~HeightMap()
{
	delete heightMap;
}

void HeightMap::load()
{
 int height = 0; 
 int offset = 0;
 char *  bmp = (char*) heightMap->pixels;

  if(heightMap != NULL /* && heightMap->format->BitsPerPixel == 8 */)
	{
		for(int i = 0; i < heightMap->h; i += 2)
			{
			for(int j = 0; j < heightMap->w;  j += 2)
			{

				// get local hight from heightMap

				
				SDL_LockSurface(heightMap);
					height = bmp[j + i*heightMap->w];
					//height = heightMap->format->palette->colors[offset];
				SDL_UnlockSurface(heightMap);	
				this->addVertex(heightMap->h - i , ((long)( height)  / 10) - 15 ,heightMap->w - j);
			}	
			}

		for(int i = 0; i < (heightMap->h * heightMap->w) / 4 - heightMap->w /2 -1  ; i ++)
			{
				  this->addFace (3, VERTEX_ONLY, i,i+1 ,i + (heightMap->w / 2) );
				
				  this->addFace (3, VERTEX_ONLY, i+1,i + (heightMap->w / 2)  ,i + (heightMap->w / 2) +1 );
			}
		

	}
  else
   	{ 
  //this->setName("HardCore");
  this->addVertex (-0.5, -0.5, 0.5);
  this->addVertex (0.5, -0.5, 0.5);
  this->addVertex (-0.5, 0.5, 0.5);
  this->addVertex (0.5, 0.5, 0.5);
  this->addVertex (-0.5, 0.5, -0.5);
  this->addVertex (0.5, 0.5, -0.5);
  this->addVertex (-0.5, -0.5, -0.5);
  this->addVertex (0.5, -0.5, -0.5);
	



  this->addFace (3, VERTEX_ONLY, 4, 3, 2);

	}
      this->finalize();


}
